<?php
/*
Plugin Name: Author Box
plugin URI: https://99robots.com/?post_type=download&p=8382
Description: Displays Author information at wihtin your posts.
version: 1.0.3
Author: 99 Robots
Author URI: https://99robots.com
License: GPL2
*/

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

/* Item Name */

if (!defined('NNROBOTS_AUTHOR_BOX_ITEM_NAME'))
    define('NNROBOTS_AUTHOR_BOX_ITEM_NAME', 'Author Box');

/* Store URL */

if (!defined('NNROBOTS_AUTHOR_BOX_STORE_URL'))
    define('NNROBOTS_AUTHOR_BOX_STORE_URL', 'https://99robots.com');

/* Minimum PHP version */

if (!defined('NNROBOTS_AUTHOR_BOX_MIN_PHP_VERSION'))
    define('NNROBOTS_AUTHOR_BOX_MIN_PHP_VERSION', '5.4.0');

/* Plugin Name */

if (!defined('NNROBOTS_AUTHOR_BOX_PLUGIN_NAME'))
    define('NNROBOTS_AUTHOR_BOX_PLUGIN_NAME', trim(dirname(plugin_basename(__FILE__)), '/'));

/* Plugin directory */

if (!defined('NNROBOTS_AUTHOR_BOX_PLUGIN_DIR'))
    define('NNROBOTS_AUTHOR_BOX_PLUGIN_DIR', plugin_dir_path(__FILE__) );

/* Plugin url */

if (!defined('NNROBOTS_AUTHOR_BOX_PLUGIN_URL'))
    define('NNROBOTS_AUTHOR_BOX_PLUGIN_URL', plugins_url() . '/' . NNROBOTS_AUTHOR_BOX_PLUGIN_NAME);

/* Plugin verison */

if (!defined('NNROBOTS_AUTHOR_BOX_VERSION_NUM'))
    define('NNROBOTS_AUTHOR_BOX_VERSION_NUM', '1.0.3');

// Activatation / Deactivation

register_activation_hook( __FILE__, 			array('NNRobots_Author_Box', 'register_activation'));

// Admin

add_action('admin_menu', 						array('NNRobots_Author_Box', 'menu'));
add_action('init', 								array('NNRobots_Author_Box', 'load_textdoamin'));
$plugin = plugin_basename(__FILE__);
add_filter("plugin_action_links_$plugin", 		array('NNRobots_Author_Box', 'settings_link'));
add_action('wp_ajax_nnr_ab_get_exclude_posts', 	array('NNRobots_Author_Box', 'get_exclude_posts'));

// User Profile

add_action('show_user_profile', 				array('NNRobots_Author_Box', 'add_field'));
add_action('edit_user_profile', 				array('NNRobots_Author_Box', 'add_field'));
add_action('personal_options_update', 			array('NNRobots_Author_Box', 'save_social'), 10, 1);
add_action('edit_user_profile_update', 			array('NNRobots_Author_Box', 'save_social'), 10, 1);

// Display the Author Box

add_filter('the_content', 						array('NNRobots_Author_Box', 'add_author_box'), 10, 1);

// Shortcode

add_shortcode('nnr_author_box', 				'nnrobots_author_box_shortcode');

// Software Licensing Updates

add_action('wp_ajax_nnr_ab_license_action', 	array('NNRobots_Author_Box', 'license_action'));

include_once('author-box-widget.php');

if ( !class_exists('EDD_SL_Plugin_Updater') ) {
	include_once( dirname( __FILE__ ) . '/admin/include/edd-software-licensing-updates/EDD_SL_Plugin_Updater.php' );
}

$edd_updater = new EDD_SL_Plugin_Updater( NNROBOTS_AUTHOR_BOX_STORE_URL , __FILE__, array(
		'version' 	=> NNROBOTS_AUTHOR_BOX_VERSION_NUM,
		'license' 	=> NNRobots_Author_Box::get_license_key(),
		'item_name' => NNROBOTS_AUTHOR_BOX_ITEM_NAME,
		'author' 	=> '99 Robots',
	)
);

/**
 * NNRobots_Author_Box class.
 */
class NNRobots_Author_Box {

	/**
	 * prefix
	 *
	 * (default value: 'nnrobots_author_box_')
	 *
	 * @var string
	 * @access public
	 * @static
	 */
	static $prefix = 'nnrobots_author_box_';

	/**
	 * prefix_dash
	 *
	 * (default value: 'nnr-ab-')
	 *
	 * @var string
	 * @access public
	 * @static
	 */
	static $prefix_dash = 'nnr-ab-';

	/**
	 * settings_page
	 *
	 * (default value: 'nnrobotos-author-box-settings')
	 *
	 * @var string
	 * @access private
	 * @static
	 */
	static $settings_page = 'nnrobotos-author-box-settings';

	/**
	 * text_domain
	 *
	 * (default value: '99robots-author-box')
	 *
	 * @var string
	 * @access private
	 * @static
	 */
	static $text_domain = '99robots-author-box';

	/**
	 * facebook_url
	 *
	 * (default value: 'https://www.facebook.com/')
	 *
	 * @var string
	 * @access private
	 * @static
	 */
	private static $facebook_url = 'https://www.facebook.com/';

	/**
	 * twitter_url
	 *
	 * (default value: 'https://twitter.com/')
	 *
	 * @var string
	 * @access private
	 * @static
	 */
	private static $twitter_url = 'https://twitter.com/';

	/**
	 * linkedin_url
	 *
	 * (default value: 'https://www.linkedin.com/')
	 *
	 * @var string
	 * @access private
	 * @static
	 */
	private static $linkedin_url = 'https://www.linkedin.com/';

	/**
	 * google_url
	 *
	 * (default value: 'https://plus.google.com/')
	 *
	 * @var string
	 * @access private
	 * @static
	 */
	private static $google_url = 'https://plus.google.com/';

	/**
	 * pinterest_url
	 *
	 * (default value: 'http://www.pinterest.com/')
	 *
	 * @var string
	 * @access private
	 * @static
	 */
	private static $pinterest_url = 'http://www.pinterest.com/';

	/**
	 * default
	 *
	 * @var mixed
	 * @access private
	 * @static
	 */
	private static $default = array(
		'display'			=> array('post'),
		'type' 				=> '1',
		'icon_size' 		=> '32',
		'icon_style' 		=> '1',
		'social_links'		=> 'text',
		'facebook' 			=> false,
		'twitter' 			=> false,
		'linkedin' 			=> false,
		'pinterest' 		=> false,
		'google' 			=> false,
		'title' 			=> false,
		'latest_posts' 		=> false,
		'location' 			=> 'bottom',
		'background_color' 	=> '#ffffff',
		'border_color' 		=> '#dddddd',
		'avatar_size'		=> '',
		'avatar_shape'		=> '',
		'post_types'		=> ''
	);

	/**
	 * Performs tasks needed upon activation
	 *
	 * @since 1.0.0
	 */
	static function register_activation() {

		// Check if multisite, if so then save as site option

		if (is_multisite()) {
			update_site_option(self::$prefix . 'version', NNROBOTS_AUTHOR_BOX_VERSION_NUM);
		} else {
			update_option(self::$prefix . 'version', NNROBOTS_AUTHOR_BOX_VERSION_NUM);
		}
	}

	/**
	 * Hooks to 'plugin_action_links_' filter
	 *
	 * @since 1.0.0
	 */
	static function settings_link($links) {
		$settings_link = '<a href="admin.php?page=' . self::$settings_page . '">Settings</a>';
		array_unshift($links, $settings_link);
		return $links;
	}

	/**
	 * Load the text domain
	 *
	 * @since 1.0.0
	 */
	static function load_textdoamin() {
		load_plugin_textdomain(self::$text_domain, false, basename( dirname( __FILE__ ) ) . '/languages' );
	}

	/**
	 * Perform all the actions with a license
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function license_action() {

		if ( !isset($_POST['license_key']) ) {
			echo '';
			die();
		}

		// data to send in our API request

		$api_params = array(
			'edd_action'	=> $_POST['license_action'],
			'license' 		=> $_POST['license_key'],
			'item_name' 	=> urlencode( NNROBOTS_AUTHOR_BOX_ITEM_NAME ), // the name of our product in EDD
			'url'       	=> is_multisite() ? network_home_url() : home_url()
		);

		// Call the custom API.

		$response = wp_remote_post( NNROBOTS_AUTHOR_BOX_STORE_URL, array( 'timeout' => 15, 'sslverify' => false, 'body' => $api_params ) );

		// make sure the response came back okay

		if ( is_wp_error( $response ) ) {
			echo $response;
			die();
		}

		$license_data = json_decode( wp_remote_retrieve_body( $response ) );

		if ( $_POST['license_action'] == 'activate_license' ) {
			self::update_license_key($_POST['license_key']);
		} else if ( $_POST['license_action'] == 'deactivate_license' && $license_data->license == 'deactivated') {
			self::update_license_key('');
		}

		// decode the license data

		echo $license_data->license;

		die();

	}

	/**
	 * Check if license key is active
	 *
	 * @access public
	 * @static
	 * @param mixed $license_key
	 * @return void
	 */
	static function is_license_active( $license_key ) {

		if ( !isset( $license_key ) ) {
			return false;
		}

		// data to send in our API request

		$api_params = array(
			'edd_action'	=> 'check_license',
			'license' 		=> $license_key,
			'item_name' 	=> urlencode( NNROBOTS_AUTHOR_BOX_ITEM_NAME ), // the name of our product in EDD
			'url'       	=> is_multisite() ? network_home_url() : home_url()
		);

		// Call the custom API.

		$response = wp_remote_post( NNROBOTS_AUTHOR_BOX_STORE_URL, array( 'timeout' => 15, 'sslverify' => false, 'body' => $api_params ) );

		// make sure the response came back okay

		if ( is_wp_error( $response ) ) {
			return false;
		}

		$license_data = json_decode( wp_remote_retrieve_body( $response ) );

		// decode the license data

		if ( isset($license_data->license) && $license_data->license == 'valid' ) {
			return true;
		} else {
			return false;
		}

	}

	/**
	 * Get the license key
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_license_key() {

		// Get the license key from based on WordPress install

		if ( function_exists('is_multisite') && is_multisite() ) {
			$license_key = get_site_option(self::$prefix . 'license_key');
		} else {
			$license_key = get_option(self::$prefix . 'license_key');
		}

		// Check if license key is set

		if ( $license_key === false ) {
			$license_key = '';
		}

		return $license_key;
	}

	/**
	 * Update the license key
	 *
	 * @access public
	 * @static
	 * @param mixed $license_key
	 * @return void
	 */
	static function update_license_key($license_key) {

		if ( isset( $license_key ) ) {

			// Get the license key from based on WordPress install

			if ( function_exists('is_multisite') && is_multisite() ) {

				update_site_option(self::$prefix . 'license_key', $license_key);

			} else {

				update_option(self::$prefix . 'license_key', $license_key);

			}
		}
	}

	/**
	 * Hook for the admin menu
	 *
	 * @since 1.0.0
	 *
	 * @param 	N/A
	 * @return 	N/A
	 */
	static function menu() {

		// Settings page

		$settings_page_load = add_submenu_page(
	 		'options-general.php',
	 		__("Author Box", self::$text_domain),
	 		__("Author Box", self::$text_domain),
	 		'manage_options',
	 		self::$settings_page,
	 		array('NNRobots_Author_Box','settings'));

	 	add_action("admin_print_scripts-$settings_page_load", array('NNRobots_Author_Box', 'admin_include_scripts'));
	}

	/**
	 * include_scripts function.
	 *
	 * Include css on admin
	 * @access public
	 * @static
	 * @return void
	 */
	static function admin_include_scripts() {

		// Styles

		wp_enqueue_style(self::$prefix . 'settings_css', 	NNROBOTS_AUTHOR_BOX_PLUGIN_URL . '/admin/css/settings.css');
		wp_enqueue_style(self::$prefix . 'bootstrap_css', 	NNROBOTS_AUTHOR_BOX_PLUGIN_URL . '/admin/css/nnr-bootstrap.min.css');
		wp_enqueue_style(self::$prefix . 'selectize_css', 	NNROBOTS_AUTHOR_BOX_PLUGIN_URL . '/admin/css/selectize.bootstrap3.css');
		wp_enqueue_style(self::$prefix . 'fontawesome_css',	NNROBOTS_AUTHOR_BOX_PLUGIN_URL . '/admin/include/fontawesome/css/font-awesome.min.css');

		// Scripts

		wp_enqueue_style('wp-color-picker');
		wp_enqueue_script(self::$prefix . 'bootstrap_js', 	NNROBOTS_AUTHOR_BOX_PLUGIN_URL . '/admin/js/bootstrap.min.js', array('jquery'));
		wp_enqueue_script(self::$prefix . 'selectize_js', 	NNROBOTS_AUTHOR_BOX_PLUGIN_URL . '/admin/js/selectize.min.js', array('jquery'));
		wp_enqueue_script(self::$prefix . 'settings_js', 	NNROBOTS_AUTHOR_BOX_PLUGIN_URL . '/admin/js/settings.js', array( 'wp-color-picker' ), false, true);
		wp_localize_script(self::$prefix . 'settings_js', 	'nnr_ab_data', array(
			'prefix_dash'			=> self::$prefix_dash,
			'post_types'			=> get_post_types(array('public' => true)),
			'activate_text'			=> __('Activate', self::$text_domain),
			'deactivate_text'		=> __('Deactivate', self::$text_domain),
			'no_license_key'		=> __('Please add or activate your License Key to get automatic updates.  Without a valid license key you will not receive regular updates. You can find your license key', self::$text_domain) . ' <a href="https://99robots.com/dashboard" target="_blank">here</a>',
			'expired'				=> __('EXPIRED: This license key has expired.  Please renew your license key', self::$text_domain) . ' <a href="https://99robots.com/dashboard" target="_blank">here</a>',
			'activation_error'		=> __('INVALID LICENSE KEY: The license key is not valid please try again. You can find your license key', self::$text_domain) . ' <a href="https://99robots.com/dashboard" target="_blank">here</a>.',
			'activation_valid'		=> __('SUCCESS: Your license key is valid.', self::$text_domain),
			'deactivation_valid'	=> __('SUCCESS: This site has been deactivated.', self::$text_domain),
			'deactivation_error'	=> __('DEACTIVATION FAILED: This site could not be deactivated.', self::$text_domain),
		));
	}

	/**
	 * Displays Options admin page
	 *
	 * @since 1.0.0
	 *
	 * @param 	N/A
	 * @return 	N/A
	 */

	static function settings() {

		global $wp_version;

		$license_key = self::get_license_key();

		$settings = get_option(self::$prefix . 'settings');

		// Default values

		if ($settings === false) {
			$settings = self::$default;
		}

		$post_types = get_post_types(array('public' => true));

		// Save Option

		if (isset($_POST['submit']) && check_admin_referer(self::$prefix . 'admin_settings')) {

			$exclude = array();

			foreach ($post_types as $post_type) {
				$exclude[$post_type] = $_POST[self::$prefix_dash . 'exclude-' . $post_type];
			}

			$settings = array(
				'background_color' 		=> isset($_POST[self::$prefix_dash . 'background-color']) ? strip_tags($_POST[self::$prefix_dash . 'background-color']) : '#ffffff',
				'text_color' 			=> isset($_POST[self::$prefix_dash . 'text-color']) ? strip_tags($_POST[self::$prefix_dash . 'text-color']) : '#333333',
				'border_color' 			=> isset($_POST[self::$prefix_dash . 'border-color']) ? strip_tags($_POST[self::$prefix_dash . 'border-color']) : '#dddddd',
				'avatar_size' 			=> isset($_POST[self::$prefix_dash . 'avatar-size']) ? $_POST[self::$prefix_dash . 'avatar-size'] : 'medium',
				'avatar_shape' 			=> isset($_POST[self::$prefix_dash . 'avatar-shape']) ? $_POST[self::$prefix_dash . 'avatar-shape'] : 'rounded-square',
				'icon_size' 			=> isset($_POST[self::$prefix_dash . 'icon-size']) ? $_POST[self::$prefix_dash . 'icon-size'] : 'medium',
				'icon_style' 			=> isset($_POST[self::$prefix_dash . 'icon-style']) ? $_POST[self::$prefix_dash . 'icon-style'] : '1',
				'icon_color' 			=> isset($_POST[self::$prefix_dash . 'icon-color']) ? strip_tags($_POST[self::$prefix_dash . 'icon-color']) : '#000000',
				'icon_background_color' => isset($_POST[self::$prefix_dash . 'icon-background-color']) ? strip_tags($_POST[self::$prefix_dash . 'icon-background-color']) : '#f4f4f4',

				'post_types'			=> isset($_POST[self::$prefix_dash . 'post-types']) ? $_POST[self::$prefix_dash . 'post-types'] : implode(',', $post_types),
				'exclude'				=> $exclude,
				'location' 				=> isset($_POST[self::$prefix_dash . 'location']) ? $_POST[self::$prefix_dash . 'location'] : 'bottom',
				'hide_author_box' 		=> isset($_POST[self::$prefix_dash . 'hide-author-box']) ? $_POST[self::$prefix_dash . 'hide-author-box'] : '.author-info',

				'type' 					=> isset($_POST[self::$prefix_dash . 'type']) ? $_POST[self::$prefix_dash . 'type'] : '1',
				'company_name' 			=> isset($_POST[self::$prefix_dash . 'company-name']) && $_POST[self::$prefix_dash . 'company-name'] ? true : false,
				'company_url' 			=> isset($_POST[self::$prefix_dash . 'company-url']) && $_POST[self::$prefix_dash . 'company-url'] ? true : false,
				'title' 				=> isset($_POST[self::$prefix_dash . 'title']) && $_POST[self::$prefix_dash . 'title'] ? true : false,
				'facebook' 				=> isset($_POST[self::$prefix_dash . 'facebook']) && $_POST[self::$prefix_dash . 'facebook'] ? true : false,
				'twitter' 				=> isset($_POST[self::$prefix_dash . 'twitter']) && $_POST[self::$prefix_dash . 'twitter'] ? true : false,
				'linkedin' 				=> isset($_POST[self::$prefix_dash . 'linkedin']) && $_POST[self::$prefix_dash . 'linkedin'] ? true : false,
				'pinterest' 			=> isset($_POST[self::$prefix_dash . 'pinterest']) && $_POST[self::$prefix_dash . 'pinterest'] ? true : false,
				'google' 				=> isset($_POST[self::$prefix_dash . 'google']) && $_POST[self::$prefix_dash . 'google'] ? true : false,
				'latest_posts' 			=> isset($_POST[self::$prefix_dash . 'latest-posts']) && $_POST[self::$prefix_dash . 'latest-posts'] ? true : false,
				'personal_website' 		=> isset($_POST[self::$prefix_dash . 'personal-website']) && $_POST[self::$prefix_dash . 'personal-website'] ? true : false,
				'social_links'			=> isset($_POST[self::$prefix_dash . 'social-links']) ? $_POST[self::$prefix_dash . 'social-links'] : 'text',
			);

			update_option(self::$prefix . 'settings', $settings);
		}

		require('admin/views/settings.php');
	}

	/**
	 * Get all exlcude posts
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_exclude_posts() {

		$post_data = array();
		$post_types = get_post_types();

		if ( isset($_POST['post_type']) && in_array($_POST['post_type'], $post_types) ) {

			global $wpdb;

			$post_data = $wpdb->get_results( "SELECT ID, post_title, post_type
		    	FROM " . $wpdb->prefix . "posts
				WHERE post_type = '" . $_POST['post_type'] . "'
				AND post_status IN('publish', 'inherit')" );
		}

		echo json_encode(array(
			'post_type'	=> $_POST['post_type'],
			'posts'		=> $post_data,
		));

		die();
	}

	/**
	 * Hook for adding field to user profile page.
	 *
	 * @since 1.0.0
	 *
	 * @param 	N/A
	 * @return 	N/A
	 */
	static function add_field() {

		if ( isset($_GET['user_id']) ) {
			$user_id = $_GET['user_id'];
		} else {
			$user_id = get_current_user_id();
		}

		// Default user data

		$social_data = get_user_meta($user_id, self::$prefix . 'social', true);

		if ( $social_data === false ) {
			$social_data = array();
		}

		$settings = get_option(self::$prefix . 'settings');

		// Default values

		if ( $settings === false ) {
			$settings = self::$default;
		}

		// Check if at least one social link is set to ture

		if (isset($settings['facebook']) || isset($settings['twitter']) || isset($settings['linkedin']) || isset($settings['pinterest']) || isset($settings['google']) || isset($settings['title'])) { ?>
			<h3><?php _e('99 Robots Author Box',self::$text_domain); ?></h3>
			<table class="form-table">
				<tbody>

					<!-- Company Name -->

					<?php if (isset($settings['company_name'])) { ?>
					<tr>
						<th>
							<label><?php _e('Company Name', self::$text_domain); ?></label>
							<td>
								<input class="regular-text" id="<?php echo self::$prefix_dash; ?>company-name" name="<?php echo self::$prefix_dash; ?>company-name" type="text" value="<?php echo (isset($social_data['company_name']) ? esc_attr($social_data['company_name']) : ''); ?>" placeholder="Example Company">
							</td>
						</th>
					</tr>
					<?php } ?>

					<!-- Company URL -->

					<?php if (isset($settings['company_url'])) { ?>
					<tr>
						<th>
							<label><?php _e('Company URL', self::$text_domain); ?></label>
							<td>
								<input class="regular-text" id="<?php echo self::$prefix_dash; ?>company-url" name="<?php echo self::$prefix_dash; ?>company-url" type="text" value="<?php echo (isset($social_data['company_url']) ? esc_attr($social_data['company_url']) : ''); ?>" placeholder="http://examplecompany.com">
							</td>
						</th>
					</tr>
					<?php } ?>

					<!-- Job Title/Position -->

					<?php if (isset($settings['title'])) { ?>
					<tr>
						<th>
							<label><?php _e('Job Title/Position', self::$text_domain); ?></label>
							<td>
								<input class="regular-text" id="<?php echo self::$prefix_dash; ?>title" name="<?php echo self::$prefix_dash; ?>title" type="text" value="<?php echo (isset($social_data['title']) ? esc_attr($social_data['title']) : ''); ?>" placeholder="Founder and CEO">
							</td>
						</th>
					</tr>
					<?php } ?>

					<!-- Facebook -->

					<?php if (isset($settings['facebook'])) { ?>
					<tr>
						<th>
							<label><?php _e('Facebook', self::$text_domain); ?></label>
							<td>
								<input class="regular-text" id="<?php echo self::$prefix_dash; ?>facebook" name="<?php echo self::$prefix_dash; ?>facebook" type="url" value="<?php echo (isset($social_data['facebook']) ? esc_attr(str_replace(self::$facebook_url, "", $social_data['facebook'])) : ''); ?>" placeholder="user_id.112233" size="40"><br/>
								<em><label><?php _e( 'https://www.facebook.com/' ); ?></label><strong><label><?php _e( '"example"' ); ?></label></strong></em><br/>
								<em><label><?php _e( 'https://www.facebook.com/' ); ?></label><strong><label><?php _e( '"pages/example/112233"' ); ?></label></strong></em><br/>
							</td>
						</th>
					</tr>
					<?php } ?>

					<!-- Twitter -->

					<?php if (isset($settings['twitter'])) { ?>
					<tr>
						<th>
							<label><?php _e('Twitter', self::$text_domain); ?></label>
							<td>
								<input class="regular-text" id="<?php echo self::$prefix_dash; ?>twitter" name="<?php echo self::$prefix_dash; ?>twitter" type="url" value="<?php echo (isset($social_data['twitter']) ? esc_attr(str_replace(self::$twitter_url, "", $social_data['twitter'])) : ''); ?>" placeholder="example" size="40"><br/>
								<em><label><?php _e( 'https://twitter.com/' ); ?></label><strong><label><?php _e( '"example"' ); ?></label></strong></em>
							</td>
						</th>
					</tr>
					<?php } ?>

					<!-- Google+ -->

					<?php if (isset($settings['google'])) { ?>
					<tr>
						<th>
							<label><?php _e('Google+', self::$text_domain); ?></label>
							<td>
								<input class="regular-text" id="<?php echo self::$prefix_dash; ?>google" name="<?php echo self::$prefix_dash; ?>google" type="url" value="<?php echo (isset($social_data['google']) ? esc_attr(str_replace(self::$google_url, "", $social_data['google'])) : ''); ?>" placeholder="112233445566" size="40"><br/>
								<em><label><?php _e( 'https://plus.google.com/'); ?></label><strong><label><?php _e('"112233"' ); ?></label></em>
							</td>
						</th>
					</tr>
					<?php } ?>

					<!-- LinkedIn -->

					<?php if (isset($settings['linkedin'])) { ?>
					<tr>
						<th>
							<label><?php _e('LinkedIn', self::$text_domain); ?></label>
							<td>
								<input class="regular-text" id="<?php echo self::$prefix_dash; ?>linkedin" name="<?php echo self::$prefix_dash; ?>linkedin" type="url" value="<?php echo (isset($social_data['linkedin']) ? esc_attr(str_replace(self::$linkedin_url, "", $social_data['linkedin'])) : ''); ?>"placeholder="example" size="40"><br/>
								<em><label><?php _e( 'http://www.linkedin.com/' ); ?></label><strong><label><?php _e( '"profile/view?id=112233"' ); ?></label></strong></em><br/>
			<em><label><?php _e( 'http://www.linkedin.com/' ); ?></label><strong><label><?php _e( '"company/112233"' ); ?></label></strong></em>
							</td>
						</th>
					</tr>
					<?php } ?>

					<!-- Pinterest -->

					<?php if (isset($settings['pinterest'])) { ?>
					<tr>
						<th>
							<label><?php _e('Pinterest', self::$text_domain); ?></label>
							<td>
								<input class="regular-text" id="<?php echo self::$prefix_dash; ?>pinterest" name="<?php echo self::$prefix_dash; ?>pinterest" type="url" value="<?php echo (isset($social_data['pinterest']) ? esc_attr(str_replace(self::$pinterest_url, "", $social_data['pinterest'])) : ''); ?>"placeholder="user_id112233" size="40"><br/>
								<em><label><?php _e( 'http://www.pinterest.com/' ); ?></label><strong><label><?php _e( '"example"' ); ?></label></strong></em>
							</td>
						</th>
					</tr>
					<?php } ?>
				</tbody>
			</table>
		<?php
		}
	}

	/**
	 * Hook for saving new fields to user profile page.
	 *
	 * @since 1.0.0
	 *
	 * @param 	N/A
	 * @return 	N/A
	 */
	static function save_social($user_id) {

		$social_data = array(
			'facebook' 		=> (!empty($_POST[self::$prefix_dash . 'facebook'])) ? self::$facebook_url . strip_tags($_POST[self::$prefix_dash . 'facebook']) : '',
			'twitter'		=> (!empty($_POST[self::$prefix_dash . 'twitter'])) ? self::$twitter_url . strip_tags($_POST[self::$prefix_dash . 'twitter']) : '',
			'linkedin'		=> (!empty($_POST[self::$prefix_dash . 'linkedin'])) ? self::$linkedin_url . strip_tags($_POST[self::$prefix_dash . 'linkedin']) : '',
			'pinterest'		=> (!empty($_POST[self::$prefix_dash . 'pinterest'])) ? self::$pinterest_url . strip_tags($_POST[self::$prefix_dash . 'pinterest']) : '',
			'google'		=> (!empty($_POST[self::$prefix_dash . 'google'])) ? self::$google_url . strip_tags($_POST[self::$prefix_dash . 'google']) : '',
			'company_name'	=> (!empty($_POST[self::$prefix_dash . 'company-name'])) ? strip_tags($_POST[self::$prefix_dash . 'company-name']) : '',
			'company_url'	=> (!empty($_POST[self::$prefix_dash . 'company-url'])) ? strip_tags($_POST[self::$prefix_dash . 'company-url']) : '',
			'title'			=> (!empty($_POST[self::$prefix_dash . 'title'])) ? strip_tags($_POST[self::$prefix_dash . 'title']) : '',
		);

		update_user_meta($user_id, self::$prefix . 'social', $social_data);
	}

	/**
	 * Hook for displaying author box to bottom of every post.
	 *
	 * @since 1.0.0
	 *
	 * @param 	N/A
	 * @return 	N/A
	 */
	static function add_author_box($content, $force_display = false, $css_class = '' ) {

		global $post;

		$post_type = get_post_type($post);
		$settings = get_option(self::$prefix . 'settings');

		// Default values

		if ( $settings === false ) {
			$settings = self::$default;
		}

		if ( !$force_display ) {

		 	// Post Types

			if ( isset($settings['post_types']) && !in_array($post->post_type, explode(',', $settings['post_types'])) ) {
				return $content;
			}

			$post_types = get_post_types(array('public' => true));

			// Exclude Posts

			foreach ( $post_types as $post_type ) {
				if ( isset( $settings['exclude'][$post_type] ) && in_array($post->ID, explode(',', $settings['exclude'][$post_type]) ) ) {
					return $content;
				}
			}
		}

		$code = '';

		// Only show on single posts

		if ( is_singular() ) {

			// Include the style sheet

			wp_enqueue_style(self::$prefix . 'css', 		NNROBOTS_AUTHOR_BOX_PLUGIN_URL . '/core/css/author-box.css');
			wp_enqueue_style(self::$prefix . 'fontawesome', NNROBOTS_AUTHOR_BOX_PLUGIN_URL . '/admin/include/fontawesome/css/font-awesome.min.css');

			$author_ID = $post->post_author;
			$author_info = get_userdata($author_ID);
			$author_social = get_user_meta($author_ID, self::$prefix . 'social', true);
			$avatar = get_avatar($author_ID);

			isset($author_social['title']) ? $author_title = $author_social['title'] : $title = '';

			$code .= '<div class="' . self::$prefix_dash . 'wrap ' . $css_class . '" style="background-color:' . $settings['background_color'] . '; border-color:' . $settings['border_color'] . ';" data-layout="' . $settings['type'] . '" data-icon-size="' . $settings['icon_size'] . '">';

			if ( $settings['type'] == '1' || $settings['type'] == '2' || $settings['type'] == '5' || $settings['type'] == '6' ) {

				// Display Avatar

				$code .= '<div class="' . self::$prefix_dash . 'author-data-container">

					<!-- Avatar -->

					<div class="' . self::$prefix_dash . 'avatar-container ' . self::$prefix_dash . 'avatar-size-' . ( isset($settings['avatar_size']) ? $settings['avatar_size'] : '' ) . ' ' . self::$prefix_dash . 'avatar-shape-' . ( isset($settings['avatar_shape']) ? $settings['avatar_shape'] : '' ) . '">'
						. $avatar .
					'</div>

					<div class="' . self::$prefix_dash . 'author-info-container" style="color:' . ( isset($settings['text_color']) ? $settings['text_color'] : '' ) . ';">

						<!-- Author Name -->

						<div class="' . self::$prefix_dash . 'author-name">' . $author_info->display_name . '</div>

						<!-- Job Title -->

						<em class="' . self::$prefix_dash . 'author-position">';

						if ( $settings['title'] && isset($author_social['title']) && $author_social['title'] != '' ) {
							$code .= '<span class="' . self::$prefix_dash . 'job-title">' . $author_social['title'] . '</span>';
						}

						if ( isset($settings['company_name']) && $settings['company_name'] && isset($author_social['company_name']) && $author_social['company_name'] != '' ) {

							if ( $settings['company_url'] ) {
								$code .= ' at <a class="' . self::$prefix_dash . 'author-company" href="' . $author_social['company_url'] . '" target="_blank">' . $author_social['company_name'] . '</a>';
							} else {
								$code .= ' at <span class="' . self::$prefix_dash . 'author-company" target="_blank">' . $author_social['company_name'] . '</span>';
							}

						}

						$code .= '</em>';

						$code .= '<!-- Biography -->

						<div class="' . self::$prefix_dash . 'author-bio">' . $author_info->user_description . '</div>';

						if ( $settings['latest_posts'] ) {
							$code .= '<div class="' . self::$prefix_dash . 'latest-posts-container"><a href="' . esc_url(get_author_posts_url($author_info->ID)) . '" target="_blank" class="' . self::$prefix_dash . 'latest-posts">' . __('Latest Posts', self::$text_domain) . '</a></div>';
						}

					$code .= '</div>

				</div>

				<div class="' . self::$prefix_dash . 'author-links-container" style="background-color:' . ( isset($settings['icon_background_color']) ? $settings['icon_background_color'] : '' ) . '; border-color:' . ( isset($settings['border_color']) ? $settings['border_color'] : '' ) . ';">';

					// Icon Size

					$icon_size = '';

					if ( isset($settings['icon_size']) && $settings['icon_size'] == 'medium' ) {
						$icon_size = 'fa-lg';
					} else if ( isset($settings['icon_size']) && $settings['icon_size'] == 'large' ) {
						$icon_size = 'fa-2x';
					}

					// Icon Style

					$icon_style = '';

					if ( isset($settings['icon_style']) && (int) $settings['icon_style'] == 1 ) {
						$icon_style .= '<span><i class="fa fa-fw ' . $icon_size . ' ' . self::$prefix_dash . 'icon';
					} else if ( isset($settings['icon_style']) && (int) $settings['icon_style'] == 2 ) {
						$icon_style .= '<span class="fa-stack fa-fw ' . $icon_size . '">
						  <i class="fa fa-circle-thin fa-stack-2x"></i>
						  <i class="fa fa-stack-1x ' . self::$prefix_dash . 'icon';
					} else if ( isset($settings['icon_style']) && (int) $settings['icon_style'] == 3 ) {
						$icon_style .= '<span class="fa-stack fa-fw ' . $icon_size . '">
						  <i class="fa fa-circle fa-stack-2x"></i>
						  <i class="fa fa-stack-1x fa-inverse ' . self::$prefix_dash . 'icon';
					} else if ( isset($settings['icon_style']) && (int) $settings['icon_style'] == 4 ) {
						$icon_style .= '<span class="fa-stack fa-fw ' . $icon_size . '">
						  <i class="fa fa-square-o fa-stack-2x"></i>
						  <i class="fa fa-stack-1x ' . self::$prefix_dash . 'icon';
					} else {
						$icon_style .= '<span class="fa-stack fa-fw ' . $icon_size . '">
						  <i class="fa fa-square fa-stack-2x"></i>
						  <i class="fa fa-stack-1x fa-inverse ' . self::$prefix_dash . 'icon';
					}

					// General Info

					if ( $settings['type'] == '5' || $settings['type'] == '6' ) {

						$side = 'top';

						if ( $settings['type'] == '6' ) {
							$side = 'left';
						}

						$code .= '<div class="' . self::$prefix_dash . 'icon-author-info" target="_blank" style="color:' . $settings['text_color'] . '; border-color:' . $settings['border_color'] . '; border-' . $side . '-color:' . $settings['background_color'] . '; background-color:' . $settings['background_color'] . ';">' . $icon_style . ' fa-user"></i></div>';

					}

					if ( isset($settings['facebook']) && $settings['facebook'] && isset($author_social['facebook']) && $author_social['facebook'] != '' )  {
						$code .= '<a href="' . esc_url($author_social['facebook']) . '" class="' . self::$prefix_dash . 'icon-link" target="_blank" style="color:' . $settings['icon_color'] . '; border-color:' . $settings['border_color'] . ';">' . $icon_style . ' fa-facebook"></i></span></a>';
					}

					if ( isset($settings['twitter']) && $settings['twitter'] && isset($author_social['twitter']) && $author_social['twitter'] != '' )  {
						$code .= '<a href="' . esc_url($author_social['twitter']) . '" class="' . self::$prefix_dash . 'icon-link" target="_blank" style="color:' . $settings['icon_color'] . '; border-color:' . $settings['border_color'] . ';">' . $icon_style . ' fa-twitter"></i></span></a>';
					}

					if ( isset($settings['linkedin']) && $settings['linkedin'] && isset($author_social['linkedin']) && $author_social['linkedin'] != '' )  {
						$code .= '<a href="' . esc_url($author_social['linkedin']) . '" class="' . self::$prefix_dash . 'icon-link" target="_blank" style="color:' . $settings['icon_color'] . '; border-color:' . $settings['border_color'] . ';">' . $icon_style . ' fa-linkedin"></i></span></a>';
					}

					if ( isset($settings['google']) && $settings['google'] && isset($author_social['google']) && $author_social['google'] != '' )  {
						$code .= '<a href="' . esc_url($author_social['google']) . '" class="' . self::$prefix_dash . 'icon-link" target="_blank" style="color:' . $settings['icon_color'] . '; border-color:' . $settings['border_color'] . ';">' . $icon_style . ' fa-google-plus"></i></span></a>';
					}

					if ( isset($settings['pinterest']) && $settings['pinterest'] && isset($author_social['pinterest']) && $author_social['pinterest'] != '' )  {
						$code .= '<a href="' . esc_url($author_social['pinterest']) . '" class="' . self::$prefix_dash . 'icon-link" target="_blank" style="color:' . $settings['icon_color'] . '; border-color:' . $settings['border_color'] . ';">' . $icon_style . ' fa-pinterest"></i></span></a>';
					}

					if ( isset($settings['personal_website']) && $settings['personal_website'] && isset($author_info->user_url) && $author_info->user_url != '' )  {
						$code .= '<a href="' . esc_url($author_info->user_url) . '" class="' . self::$prefix_dash . 'icon-link" target="_blank" style="color:' . $settings['icon_color'] . '; border-color:' . $settings['border_color'] . ';">' . $icon_style . ' fa-link"></i></span></a>';
					}

					$code .= '<a href="' . get_site_url() . '/author/' . $author_info->user_login . '/feed" class="' . self::$prefix_dash . 'icon-link" target="_blank" style="color:' . ( isset($settings['icon_color']) ? $settings['icon_color'] : '' ) . '; border-color:' . ( isset($settings['border_color']) ? $settings['border_color'] : '' ) . ';">' . $icon_style . ' fa-rss"></i></span></a>';

				$code .= '</div>';

			}

			else if ( $settings['type'] == '3' || $settings['type'] == '4' || $settings['type'] == '7' || $settings['type'] == '8' ) {

				// Links

				$code .= '<div class="' . self::$prefix_dash . 'author-links-container" style="background-color:' . $settings['icon_background_color'] . '; border-color:' . $settings['border_color'] . ';">';

					// Icon Size

					$icon_size = '';

					if ( isset($settings['icon_size']) && $settings['icon_size'] == 'medium' ) {
						$icon_size = 'fa-lg';
					} else if ( isset($settings['icon_size']) && $settings['icon_size'] == 'large' ) {
						$icon_size = 'fa-2x';
					}

					// Icon Style

					$icon_style = '';

					if ( isset($settings['icon_style']) && (int) $settings['icon_style'] == 1 ) {
						$icon_style .= '<span><i class="fa fa-fw ' . $icon_size . ' ' . self::$prefix_dash . 'icon';
					} else if ( isset($settings['icon_style']) && (int) $settings['icon_style'] == 2 ) {
						$icon_style .= '<span class="fa-stack fa-fw ' . $icon_size . '">
						  <i class="fa fa-circle-thin fa-stack-2x"></i>
						  <i class="fa fa-stack-1x ' . self::$prefix_dash . 'icon';
					} else if ( isset($settings['icon_style']) && (int) $settings['icon_style'] == 3 ) {
						$icon_style .= '<span class="fa-stack fa-fw ' . $icon_size . '">
						  <i class="fa fa-circle fa-stack-2x"></i>
						  <i class="fa fa-stack-1x fa-inverse fa-fw ' . self::$prefix_dash . 'icon';
					} else if ( isset($settings['icon_style']) && (int) $settings['icon_style'] == 4 ) {
						$icon_style .= '<span class="fa-stack fa-fw ' . $icon_size . '">
						  <i class="fa fa-square-o fa-stack-2x"></i>
						  <i class="fa fa-stack-1x ' . self::$prefix_dash . 'icon';
					} else {
						$icon_style .= '<span class="fa-stack fa-fw ' . $icon_size . '">
						  <i class="fa fa-square fa-stack-2x"></i>
						  <i class="fa fa-stack-1x fa-inverse ' . self::$prefix_dash . 'icon';
					}

					// General Info

					if ( $settings['type'] == '7' || $settings['type'] == '8' ) {

						$side = 'bottom';

						if ( $settings['type'] == '8' ) {
							$side = 'right';
						}

						$code .= '<div class="' . self::$prefix_dash . 'icon-author-info" target="_blank" style="color:' . $settings['text_color'] . '; border-color:' . $settings['border_color'] . '; border-' . $side . '-color:' . $settings['background_color'] . '; background-color:' . $settings['background_color'] . ';">' . $icon_style . ' fa-user"></i></div>';

					}

					if ( $settings['facebook'] && isset($author_social['facebook']) && $author_social['facebook'] != '' )  {
						$code .= '<a href="' . esc_url($author_social['facebook']) . '" class="' . self::$prefix_dash . 'icon-link" target="_blank" style="color:' . $settings['icon_color'] . '; border-color:' . $settings['border_color'] . ';">' . $icon_style . ' fa-facebook"></i></span></a>';
					}

					if ( $settings['twitter'] && isset($author_social['twitter']) && $author_social['twitter'] != '' )  {
						$code .= '<a href="' . esc_url($author_social['twitter']) . '" class="' . self::$prefix_dash . 'icon-link" target="_blank" style="color:' . $settings['icon_color'] . '; border-color:' . $settings['border_color'] . ';">' . $icon_style . ' fa-twitter"></i></span></a>';
					}

					if ( $settings['linkedin'] && isset($author_social['linkedin']) && $author_social['linkedin'] != '' )  {
						$code .= '<a href="' . esc_url($author_social['linkedin']) . '" class="' . self::$prefix_dash . 'icon-link" target="_blank" style="color:' . $settings['icon_color'] . '; border-color:' . $settings['border_color'] . ';">' . $icon_style . ' fa-linkedin"></i></span></a>';
					}

					if ( $settings['google'] && isset($author_social['google']) && $author_social['google'] != '' )  {
						$code .= '<a href="' . esc_url($author_social['google']) . '" class="' . self::$prefix_dash . 'icon-link" target="_blank" style="color:' . $settings['icon_color'] . '; border-color:' . $settings['border_color'] . ';">' . $icon_style . ' fa-google-plus"></i></span></a>';
					}

					if ( $settings['pinterest'] && isset($author_social['pinterest']) && $author_social['pinterest'] != '' )  {
						$code .= '<a href="' . esc_url($author_social['pinterest']) . '" class="' . self::$prefix_dash . 'icon-link" target="_blank" style="color:' . $settings['icon_color'] . '; border-color:' . $settings['border_color'] . ';">' . $icon_style . ' fa-pinterest"></i></span></a>';
					}

					if ( $settings['personal_website'] && isset($author_info->user_url) && $author_info->user_url != '' )  {
						$code .= '<a href="' . esc_url($author_info->user_url) . '" class="' . self::$prefix_dash . 'icon-link" target="_blank" style="color:' . $settings['icon_color'] . '; border-color:' . $settings['border_color'] . ';">' . $icon_style . ' fa-link"></i></span></a>';
					}

					$code .= '<a href="' . get_site_url() . '/author/' . $author_info->user_login . '/feed" class="' . self::$prefix_dash . 'icon-link" target="_blank" style="color:' . $settings['icon_color'] . '; border-color:' . $settings['border_color'] . ';">' . $icon_style . ' fa-rss"></i></span></a>';

				$code .= '</div>';

				// Avatar

				$code .= ' <div class="' . self::$prefix_dash . 'author-data-container">

					<!-- Avatar -->

					<div class="' . self::$prefix_dash . 'avatar-container ' . self::$prefix_dash . 'avatar-size-' . $settings['avatar_size'] . ' ' . self::$prefix_dash . 'avatar-shape-' . $settings['avatar_shape'] . '">'
						. $avatar .
					'</div>

					<div class="' . self::$prefix_dash . 'author-info-container" style="color:' . $settings['text_color'] . ';">

						<!-- Author Name -->

						<div class="' . self::$prefix_dash . 'author-name">' . $author_info->display_name . '</div>

						<!-- Job Title -->

						<em class="' . self::$prefix_dash . 'author-position">';

						if ( $settings['title'] && isset($author_social['title']) && $author_social['title'] != '' ) {
							$code .= '<span class="' . self::$prefix_dash . 'job-title">' . $author_social['title'] . '</span>';
						}

						if ( $settings['company_name'] && isset($author_social['company_name']) && $author_social['company_name'] != '' ) {

							if ( $settings['company_url'] ) {
								$code .= ' at <a class="' . self::$prefix_dash . 'author-company" href="' . $author_social['company_url'] . '" target="_blank">' . $author_social['company_name'] . '</a>';
							} else {
								$code .= ' at <span class="' . self::$prefix_dash . 'author-company" target="_blank">' . $author_social['company_name'] . '</span>';
							}

						}

						$code .= '</em>';

						$code .= '<!-- Biography -->

						<div class="' . self::$prefix_dash . 'author-bio">' . $author_info->user_description . '</div>';

						if ( $settings['latest_posts'] ) {
							$code .= '<div class="' . self::$prefix_dash . 'latest-posts-container"><a href="' . esc_url(get_author_posts_url($author_info->ID)) . '" target="_blank" class="' . self::$prefix_dash . 'latest-posts">' . __('Latest Posts', self::$text_domain) . '</a></div>';
						}

					$code .= '</div>
				</div>';

			}

			else if ( $settings['type'] == '9' ) {

				// Avatar

				$code .= ' <div class="' . self::$prefix_dash . 'author-data-container">

					<!-- Avatar -->

					<div class="' . self::$prefix_dash . 'avatar-container ' . self::$prefix_dash . 'avatar-size-' . $settings['avatar_size'] . ' ' . self::$prefix_dash . 'avatar-shape-' . $settings['avatar_shape'] . '">'
						. $avatar .
					'</div>

					<div class="' . self::$prefix_dash . 'author-info-container" style="color:' . $settings['text_color'] . ';">

						<!-- Author Name -->

						<div class="' . self::$prefix_dash . 'author-name">' . $author_info->display_name . '</div>

						<!-- Job Title -->

						<em class="' . self::$prefix_dash . 'author-position">';

						if ( $settings['title'] &&  isset($author_social['title']) && $author_social['title'] != '' ) {
							$code .= '<span class="' . self::$prefix_dash . 'job-title">' . $author_social['title'] . '</span>';
						}

						if ( $settings['company_name'] && isset($author_social['company_name']) && $author_social['company_name'] != '' ) {

							if ( $settings['company_url'] ) {
								$code .= ' at <a class="' . self::$prefix_dash . 'author-company" href="' . $author_social['company_url'] . '" target="_blank">' . $author_social['company_name'] . '</a>';
							} else {
								$code .= ' at <span class="' . self::$prefix_dash . 'author-company" target="_blank">' . $author_social['company_name'] . '</span>';
							}

						}

						$code .= '</em>';

						$code .= '<!-- Biography -->

						<div class="' . self::$prefix_dash . 'author-bio">' . $author_info->user_description . '</div>';

						if ( $settings['latest_posts'] ) {
							$code .= '<div class="' . self::$prefix_dash . 'latest-posts-container"><a href="' . esc_url(get_author_posts_url($author_info->ID)) . '" target="_blank" class="' . self::$prefix_dash . 'latest-posts">' . __('Latest Posts', self::$text_domain) . '</a></div>';
						}

					$code .= '</div>
				</div>';

			}

			$code .= '</div> <!-- ' . self::$prefix_dash . 'wrap -->
			<style>' . ( isset($settings['hide_author_box']) ? $settings['hide_author_box'] : '' ) . ' { display: none !important;}</style>';

			if ( $force_display ) {
				return $code;
			}

			if (isset($settings['location']) && $settings['location'] == 'top') {
				return $code . $content;
			} else if (isset($settings['location']) && $settings['location'] == 'bottom') {
				return $content . $code;
			} else if (isset($settings['location']) && $settings['location'] == 'other') {
				return $content;
			}
		}

		return $content;
	}
}

/**
 * Create shortcode [nnr_author_box ...]
 *
 * @since 1.0.0
 *
 * @param 	array id
 * @return 	html code
 */
function nnrobots_author_box_shortcode($atts) {

	return NNRobots_Author_Box::add_author_box('', true, NNRobots_Author_Box::$prefix_dash . 'shortcode');
}
